/*
 * 
 * Example FlagMaker: draw some flags at click points.
 *
 * Jim Teresco, Siena College, CSIS 120, Spring 2011
 * Based on example from CSCI 134, Williams College
 *
 * $Id: MovingFlags.java 2218 2013-10-18 14:06:39Z terescoj $
 */

import java.awt.*;
import objectdraw.*;
import java.util.ArrayList;

public class MovingFlags extends WindowController {

    private ArrayList<Flag> flags;
    private boolean dragging;
    private Flag selectedFlag;
    private Location lastMouse;
    
    public void begin() {

        flags = new ArrayList<Flag>();
        
        new Text("Click to draw a flag", 10, 10,canvas);
    }

    public void onMousePress(Location point) {

        dragging = false;
        
        // if point is on a flag, start dragging it
        for (int flagNum = 0; flagNum < flags.size(); flagNum++) {
            if (flags.get(flagNum).contains(point)) {
                dragging = true;
                selectedFlag = flags.get(flagNum);
                lastMouse = point;
            }
        }
        // if not, create a new flag
        if (!dragging) {
            flags.add(new Flag(point, canvas));
        }
    }
    
    public void onMouseDrag(Location point) {
        
        if (dragging) {
            selectedFlag.move(point.getX() - lastMouse.getX(),
                              point.getY() - lastMouse.getY());
            lastMouse = point;
        }
    }
}
